Package org.h2.expression

# Class ExpressionColumn

java.lang.Object
org.h2.expression.Expression
org.h2.expression.ExpressionColumn

All Implemented Interfaces:
  `HasSQL`, `Typed`

public final class ExpressionColumn extends Expression
A column reference expression that represents a column of a table or view.

## Field Summary

### Fields inherited from class org.h2.expression.Expression

`AUTO_PARENTHESES, MAP_IN_AGGREGATE, MAP_IN_WINDOW, MAP_INITIAL, WITH_PARENTHESES, WITHOUT_PARENTHESES`

### Fields inherited from interface org.h2.util.HasSQL

`ADD_PLAN_INFORMATION, DEFAULT_SQL_FLAGS, NO_CASTS, QUOTE_ONLY_WHEN_REQUIRED, REPLACE_LOBS_FOR_TRACE, TRACE_SQL_FLAGS`

## Constructor Summary

Constructors
Constructor
Description
`ExpressionColumn(Database database, String schemaName, String tableAlias)`
Creates a new instance of column reference for `_ROWID_` column as normal expression.
`ExpressionColumn(Database database, String schemaName, String tableAlias, String columnName)`
Creates a new instance of column reference for regular columns as normal expression.
`ExpressionColumn(Database database, String schemaName, String tableAlias, String columnName, boolean quotedName)`
Creates a new instance of column reference for regular columns as normal expression.
`ExpressionColumn(Database database, Column column)`
Creates a new column reference for metadata of queries; should not be used as normal expression.

## Method Summary

Modifier and Type
Method
Description
`void`
`createIndexConditions(SessionLocal session, TableFilter filter)`
Create index conditions if possible and attach them to the table filter.
`String`
`getAlias(SessionLocal session, int columnIndex)`
Get the alias name of a column or SQL expression if it is not an aliased expression.
`Column`
`getColumn()`
`DbException`
`getColumnException(int code)`
Get exception to throw, with column and table info added
`String`
`getColumnName(SessionLocal session, int columnIndex)`
Get the column name or alias name of this expression.
`String`
`getColumnNameForView(SessionLocal session, int columnIndex)`
Get the column name of this expression for a view.
`int`
`getCost()`
Estimate the cost to process the expression.
`Expression`
`getNotIfPossible(SessionLocal session)`
If it is possible, return the negated expression.
`int`
`getNullable()`
Check whether this expression is a column and can store NULL.
`String`
`getOriginalColumnName()`
`String`
`getOriginalTableAliasName()`
`String`
`getSchemaName()`
Get the schema name, or null
`TableFilter`
`getTableFilter()`
`String`
`getTableName()`
Get the table name, or null
`TypeInfo`
`getType()`
Returns the data type.
`StringBuilder`
`getUnenclosedSQL(StringBuilder builder, int sqlFlags)`
Get the SQL statement of this expression.
`Value`
`getValue(SessionLocal session)`
Return the resulting value for the current row.
`boolean`
`isEverything(ExpressionVisitor visitor)`
Check if this expression and all sub-expressions can fulfill a criteria.
`boolean`
`isIdentity()`
Check if this is an identity column.
`void`
`mapColumns(ColumnResolver resolver, int level, int state)`
Map the columns of the resolver to expression columns.
`Expression`
`optimize(SessionLocal session)`
Try to optimize the expression.
`void`
`setEvaluatable(TableFilter tableFilter, boolean b)`
Tell the expression columns whether the table filter can return values now.
`void`
`updateAggregate(SessionLocal session, int stage)`
Update an aggregate value.

### Methods inherited from class org.h2.expression.Expression

`addFilterConditions, getBooleanValue, getEnclosedSQL, getNonAliasExpression, getSQL, getSQL, getSQL, getSQL, getSubexpression, getSubexpressionCount, getTableAlias, getTypeIfStaticallyKnown, getWhenSQL, getWhenValue, isConstant, isNullConstant, isValueSet, isWhenConditionOperand, needParentheses, optimizeCondition, toString, writeExpressions, writeExpressions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.h2.util.HasSQL

`getTraceSQL`

## Constructor Details

### ExpressionColumn

public ExpressionColumn(Database database, Column column)
Creates a new column reference for metadata of queries; should not be used as normal expression.

Parameters:
  `database` - the database
  `column` - the column

### ExpressionColumn

public ExpressionColumn(Database database, String schemaName, String tableAlias, String columnName)
Creates a new instance of column reference for regular columns as normal expression.

Parameters:
  `database` - the database
  `schemaName` - the schema name, or `null`
  `tableAlias` - the table alias name, table name, or `null`
  `columnName` - the column name

### ExpressionColumn

public ExpressionColumn(Database database, String schemaName, String tableAlias, String columnName, boolean quotedName)
Creates a new instance of column reference for regular columns as normal expression.

Parameters:
  `database` - the database
  `schemaName` - the schema name, or `null`
  `tableAlias` - the table alias name, table name, or `null`
  `columnName` - the column name
  `quotedName` - whether name was quoted

### ExpressionColumn

public ExpressionColumn(Database database, String schemaName, String tableAlias)
Creates a new instance of column reference for `_ROWID_` column as normal expression.

Parameters:
  `database` - the database
  `schemaName` - the schema name, or `null`
  `tableAlias` - the table alias name, table name, or `null`

## Method Details

### getUnenclosedSQL

public StringBuilder getUnenclosedSQL(StringBuilder builder, int sqlFlags)
Description copied from class: `Expression`
Get the SQL statement of this expression. This may not always be the original SQL statement, especially after optimization. Enclosing '(' and ')' are never appended.

Specified by:
  `getUnenclosedSQL` in class `Expression`
Parameters:
  `builder` - string builder
  `sqlFlags` - formatting flags
Returns:
  the specified string builder

### getTableFilter

public TableFilter getTableFilter()

### mapColumns

public void mapColumns(ColumnResolver resolver, int level, int state)
Description copied from class: `Expression`
Map the columns of the resolver to expression columns.

Specified by:
  `mapColumns` in class `Expression`
Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level
  `state` - current state for nesting checks, initial value is `Expression.MAP_INITIAL`

### optimize

public Expression optimize(SessionLocal session)
Description copied from class: `Expression`
Try to optimize the expression.

Specified by:
  `optimize` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the optimized expression

### getColumnException

public DbException getColumnException(int code)
Get exception to throw, with column and table info added

Parameters:
  `code` - SQL error code
Returns:
  DbException

### updateAggregate

public void updateAggregate(SessionLocal session, int stage)
Description copied from class: `Expression`
Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Specified by:
  `updateAggregate` in class `Expression`
Parameters:
  `session` - the session
  `stage` - select stage

### getValue

public Value getValue(SessionLocal session)
Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

### getType

public TypeInfo getType()
Description copied from class: `Expression`
Returns the data type. The data type may be unknown before the optimization phase.

Specified by:
  `getType` in interface `Typed`
Specified by:
  `getType` in class `Expression`
Returns:
  the data type

### setEvaluatable

public void setEvaluatable(TableFilter tableFilter, boolean b)
Description copied from class: `Expression`
Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Specified by:
  `setEvaluatable` in class `Expression`
Parameters:
  `tableFilter` - the table filter
  `b` - true if the table filter can return value

### getColumn

public Column getColumn()

### getOriginalColumnName

public String getOriginalColumnName()

### getOriginalTableAliasName

public String getOriginalTableAliasName()

### getColumnName

public String getColumnName(SessionLocal session, int columnIndex)
Description copied from class: `Expression`
Get the column name or alias name of this expression.

Overrides:
  `getColumnName` in class `Expression`
Parameters:
  `session` - the session
  `columnIndex` - 0-based column index
Returns:
  the column name

### getSchemaName

public String getSchemaName()
Description copied from class: `Expression`
Get the schema name, or null

Overrides:
  `getSchemaName` in class `Expression`
Returns:
  the schema name

### getTableName

public String getTableName()
Description copied from class: `Expression`
Get the table name, or null

Overrides:
  `getTableName` in class `Expression`
Returns:
  the table name

### getAlias

public String getAlias(SessionLocal session, int columnIndex)
Description copied from class: `Expression`
Get the alias name of a column or SQL expression if it is not an aliased expression.

Overrides:
  `getAlias` in class `Expression`
Parameters:
  `session` - the session
  `columnIndex` - 0-based column index
Returns:
  the alias name

### getColumnNameForView

public String getColumnNameForView(SessionLocal session, int columnIndex)
Description copied from class: `Expression`
Get the column name of this expression for a view.

Overrides:
  `getColumnNameForView` in class `Expression`
Parameters:
  `session` - the session
  `columnIndex` - 0-based column index
Returns:
  the column name for a view

### isIdentity

public boolean isIdentity()
Description copied from class: `Expression`
Check if this is an identity column.

Overrides:
  `isIdentity` in class `Expression`
Returns:
  true if it is an identity column

### getNullable

public int getNullable()
Description copied from class: `Expression`
Check whether this expression is a column and can store NULL.

Overrides:
  `getNullable` in class `Expression`
Returns:
  whether NULL is allowed

### isEverything

public boolean isEverything(ExpressionVisitor visitor)
Description copied from class: `Expression`
Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Specified by:
  `isEverything` in class `Expression`
Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

### getCost

public int getCost()
Description copied from class: `Expression`
Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Specified by:
  `getCost` in class `Expression`
Returns:
  the estimated cost

### createIndexConditions

public void createIndexConditions(SessionLocal session, TableFilter filter)
Description copied from class: `Expression`
Create index conditions if possible and attach them to the table filter.

Overrides:
  `createIndexConditions` in class `Expression`
Parameters:
  `session` - the session
  `filter` - the table filter

### getNotIfPossible

public Expression getNotIfPossible(SessionLocal session)
Description copied from class: `Expression`
If it is possible, return the negated expression. This is used to optimize NOT expressions: NOT ID>10 can be converted to ID<=10. Returns null if negating is not possible.

Overrides:
  `getNotIfPossible` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the negated expression, or null